Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/VERSION
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/VERSION	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/VERSION	(revision 53)
@@ -0,0 +1,4 @@
+v0.6
+
+0.5 modif vhdl_port et vhdl_testbench_port -> ajout d'une macro
+0.6 ajout de la documentation
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/doc/Makefile
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/doc/Makefile	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/doc/Makefile	(revision 53)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h	(revision 53)
@@ -0,0 +1,104 @@
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_multi_banked_Parameters_h
+#define morpheo_behavioural_generic_registerfile_registerfile_multi_banked_Parameters_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Debug.h"
+#include "Common/include/FromString.h"
+#include "Behavioural/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Types.h"
+#include <math.h>
+
+namespace morpheo {
+  typedef enum {PARTIAL_CROSSBAR,
+		FULL_CROSSBAR   } Tcrossbar_t;
+
+  template<> inline Tcrossbar_t fromString<Tcrossbar_t> (const std::string& x)
+  {
+    if ( (x.compare("0")                == 0) or
+	 (x.compare("PARTIAL_CROSSBAR") == 0))
+      return PARTIAL_CROSSBAR;
+    if ( (x.compare("1")                == 0) or
+	 (x.compare("FULL_CROSSBAR"   ) == 0))
+      return FULL_CROSSBAR;
+
+    throw (ErrorMorpheo ("<fromString> : Unknow string : \""+x+"\""));
+  };
+  
+  template<> inline std::string toString<Tcrossbar_t>   (const Tcrossbar_t& x)
+  {
+    ostringstream out;
+
+    if (x == PARTIAL_CROSSBAR)
+      out << "PARTIAL_CROSSBAR";
+    if (x == FULL_CROSSBAR)
+      out << "FULL_CROSSBAR";
+
+    return out.str();
+  };
+
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  class Parameters : public morpheo::behavioural::Parameters
+  {
+    //-----[ fields ]------------------------------------------------------------
+  public : const uint32_t    _nb_port_read         ; // Global read  port
+  public : const uint32_t    _nb_port_write        ; // Global write port
+  public : const uint32_t    _nb_word              ;
+  public : const uint32_t    _size_word            ;
+  public : const uint32_t    _nb_bank              ; // Number of bank (All bank is identical)
+  public : const uint32_t    _nb_port_read_by_bank ; // Local  read  port
+  public : const uint32_t    _nb_port_write_by_bank; // Local  write port
+  public : const Tcrossbar_t _crossbar             ;
+
+  public : const uint32_t    _size_address         ;
+  public : const uint32_t    _size_address_by_bank ;
+
+  public : const uint32_t    _bank_shift           ;
+  public : const Taddress_t  _bank_mask            ;
+  public : const uint32_t    _num_reg_shift        ;
+  public : const Taddress_t  _num_reg_mask         ;
+
+  public : const uint32_t    _nb_word_by_bank      ;
+
+    // A lot of table to the partial crossbar
+  public :       uint32_t  * _link_port_read_to_bank_read  ;
+//   public :       uint32_t  * _link_port_read_to_num_bank   ;
+  public :       uint32_t  * _link_port_write_to_bank_write;
+//   public :       uint32_t  * _link_port_write_to_num_bank  ;
+
+    //-----[ methods ]-----------------------------------------------------------
+  public : Parameters  (uint32_t    nb_port_read         ,
+			uint32_t    nb_port_write        ,
+			uint32_t    nb_word              ,
+			uint32_t    size_word            ,
+			uint32_t    nb_bank              ,
+			uint32_t    nb_port_read_by_bank ,
+			uint32_t    nb_port_write_by_bank,
+			Tcrossbar_t crossbar             );
+  public : Parameters  (Parameters & param) ;
+  public : ~Parameters () ;
+
+  public : string msg_error (void);
+
+  public :        string   print      (uint32_t depth);
+  public : friend ostream& operator<< (ostream& output_stream,
+				       morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters & x);
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h	(revision 53)
@@ -0,0 +1,157 @@
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_multi_banked_RegisterFile_Multi_Banked_h
+#define morpheo_behavioural_generic_registerfile_registerfile_multi_banked_RegisterFile_Multi_Banked_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#include <iostream>
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Types.h"
+#ifdef STATISTICS
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Statistics.h"
+#endif
+#include "Behavioural/include/Component.h"
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+
+using namespace std;
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  class RegisterFile_Multi_Banked 
+#if SYSTEMC
+    : public sc_module
+#endif
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  protected : const string     _name;
+
+  protected : const Parameters _param;
+//#ifdef STATISTICS
+//  protected : const morpheo::behavioural::Parameters_Statistics _param_statistics;
+//#endif
+
+#ifdef STATISTICS
+  private   : Statistics                     * _stat;
+#endif
+
+  public    : Component                      * _component;
+  private   : Interfaces                     * _interfaces;
+
+#ifdef SYSTEMC
+    // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // Interface
+  public    : SC_CLOCK                      *  in_CLOCK        ;
+  public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
+
+    // ----- Interface Read
+  public    : SC_IN       (Tcontrol_t)     **  in_READ_VAL     ;
+  public    : SC_OUT      (Tcontrol_t)     ** out_READ_ACK     ;
+  public    : SC_IN       (Taddress_t)     **  in_READ_ADDRESS ;
+  public    : SC_OUT      (Tdata_t)        ** out_READ_DATA    ;
+
+    // ----- Interface Write
+  public    : SC_IN       (Tcontrol_t)     **  in_WRITE_VAL    ;
+  public    : SC_OUT      (Tcontrol_t)     ** out_WRITE_ACK    ;
+  public    : SC_IN       (Taddress_t)     **  in_WRITE_ADDRESS;
+  public    : SC_IN       (Tdata_t)        **  in_WRITE_DATA   ;
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+  private   : SC_REGISTER (Tdata_t)       *** reg_DATA         ;
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  private   : bool                          * internal_WRITE_VAL;
+  private   : Taddress_t                    * internal_WRITE_BANK;
+  private   : Taddress_t                    * internal_WRITE_NUM_REG;
+
+        // function pointer
+  public    : void (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::*function_transition    ) (void);
+  public    : void (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::*function_genMealy_read ) (void);
+  public    : void (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::*function_genMealy_write) (void);
+#endif
+
+    // -----[ methods ]---------------------------------------------------
+
+#ifdef SYSTEMC
+    SC_HAS_PROCESS (RegisterFile_Multi_Banked);
+#endif
+  public  :          RegisterFile_Multi_Banked              (
+#ifdef SYSTEMC
+					      sc_module_name                              name,
+#else					       
+					      string                                      name,
+#endif					       
+#ifdef STATISTICS
+					      morpheo::behavioural::Parameters_Statistics param_statistics,
+#endif
+					      Parameters                                  param );
+					       
+  public  :          RegisterFile_Multi_Banked              (Parameters param );
+  public  :          ~RegisterFile_Multi_Banked             (void);
+					       
+#ifdef SYSTEMC				       
+  private : void     allocation                (void);
+  private : void     deallocation              (void);
+					       
+//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+
+  private : Taddress_t address_bank                 (Taddress_t address);
+  private : Taddress_t address_num_reg              (Taddress_t address);
+
+  public  : void     transition                     (void);
+  public  : void     genMealy_read                  (void);
+  public  : void     genMealy_write                 (void);
+
+  public  : void     full_crossbar_transition       (void);
+  public  : void     full_crossbar_genMealy_read    (void);
+  public  : void     full_crossbar_genMealy_write   (void);
+
+  public  : void     partial_crossbar_transition    (void);
+  public  : void     partial_crossbar_genMealy_read (void);
+  public  : void     partial_crossbar_genMealy_write(void);
+
+//#endif
+#endif					       
+#ifdef STATISTICS
+  public  : string   statistics                (uint32_t depth);
+#endif
+					       
+#if VHDL				       
+  public  : void     vhdl                      (void);
+  private : void     vhdl_declaration          (Vhdl * & vhdl);
+  private : void     vhdl_body                 (Vhdl * & vhdl);
+#endif					       
+					       
+#ifdef VHDL_TESTBENCH			       
+  private : void     vhdl_testbench_transition (void);
+#endif
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Statistics.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Statistics.h	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Statistics.h	(revision 53)
@@ -0,0 +1,57 @@
+#ifdef STATISTICS
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_multi_banked_Statistics_h
+#define morpheo_behavioural_generic_registerfile_registerfile_multi_banked_Statistics_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Debug.h"
+#include "Behavioural/include/Statistics.h"
+#include "Behavioural/include/Parameters_Statistics.h"
+//#include "Behavioural/Generic/Group/include/Statistics.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h"
+
+//using namespace morpheo::behavioural::generic::group;
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  class Statistics : public morpheo::behavioural::Statistics
+  {
+    // -----[ fields ]----------------------------------------------------
+  private  : const Parameters                                   _parameters;
+
+    // -----[ methods ]---------------------------------------------------
+  public   : Statistics  (string                                      name                       ,
+			  morpheo::behavioural::Parameters_Statistics parameters_statistics      ,
+			  Parameters                                  parameters
+			  );
+//public   : Statistics  (Statistics & stat);
+  public   : ~Statistics () ;
+    
+  public   : string   print_body (uint32_t depth);
+  public   : string   print      (uint32_t depth);
+  public   : void     add        ();
+
+  public   : friend ostream& operator<< (ostream& output_stream,
+					 const Statistics & x);
+
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo
+
+#endif
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Types.h	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Types.h	(revision 53)
@@ -0,0 +1,29 @@
+#ifndef morpheo_behavioural_generic_registerfile_registerfile_multi_banked_Type_h
+#define morpheo_behavioural_generic_registerfile_registerfile_multi_banked_Type_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Types.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+  typedef uint32_t Taddress_t;
+  typedef uint32_t Tdata_t;
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters.cpp	(revision 53)
@@ -0,0 +1,170 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h"
+#include "Common/include/BitManipulation.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  Parameters::Parameters (uint32_t    nb_port_read         ,
+			  uint32_t    nb_port_write        ,
+			  uint32_t    nb_word              ,
+			  uint32_t    size_word            ,
+			  uint32_t    nb_bank              ,
+			  uint32_t    nb_port_read_by_bank ,
+			  uint32_t    nb_port_write_by_bank,
+			  Tcrossbar_t crossbar             ):
+    _nb_port_read          (nb_port_read         ),
+    _nb_port_write         (nb_port_write        ),
+    _nb_word               (nb_word              ),
+    _size_word             (size_word            ),
+    _nb_bank               (nb_bank              ),
+    _nb_port_read_by_bank  (nb_port_read_by_bank ),
+    _nb_port_write_by_bank (nb_port_write_by_bank),
+    _crossbar              (crossbar             ),
+    _size_address          (static_cast<uint32_t>(ceil(log2(_nb_word)))),
+    _size_address_by_bank  (_size_address - static_cast<uint32_t>(ceil(log2(_nb_bank)))),
+
+    // Address : [....................]  [size_address-1:0]
+    // Bank    : [....]                  [size_address-1:size_address-1-log2(nb_bank)]
+    // num_reg :      ]...............]  [size_address-2-log2(nb_bank):0]
+    _bank_shift            (_size_address_by_bank),
+    _bank_mask             (gen_mask<Taddress_t>(static_cast<Taddress_t>(ceil(log2(_nb_bank))))),
+    _num_reg_shift         (0),
+    _num_reg_mask          (gen_mask<Taddress_t>(_size_address_by_bank)),
+    _nb_word_by_bank       (_nb_word / _nb_bank)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"Parameters","Begin");
+
+    if (_crossbar == PARTIAL_CROSSBAR)
+      {
+	log_printf(NONE,RegisterFile_Multi_Banked,"Parameters","Case : _crossbar == PARTIAL_CROSSBAR");
+
+	// All port_src is connected with one port_dest on each bank
+	
+	_link_port_read_to_bank_read     = new uint32_t [_nb_port_read ];
+// 	_link_port_read_to_num_bank      = new uint32_t [_nb_port_read ];
+	_link_port_write_to_bank_write   = new uint32_t [_nb_port_write];
+// 	_link_port_write_to_num_bank     = new uint32_t [_nb_port_write];
+
+// 	uint32_t _nb_port_bank_by_bank_read_port  [_nb_port_read_by_bank ];
+// 	uint32_t _nb_port_bank_by_bank_write_port [_nb_port_write_by_bank];
+	
+	// init
+// 	for (uint32_t i=0; i<_nb_port_read_by_bank ;i++)
+// 	  _nb_port_bank_by_bank_read_port  [i] = 0;
+	
+	for (uint32_t i=0; i<_nb_port_read         ;i++)
+	  {
+	    uint32_t x = i%_nb_port_read_by_bank;
+	    _link_port_read_to_bank_read [i] = x;
+// 	    _link_port_read_to_num_bank  [i] = _nb_port_bank_by_bank_read_port [x];
+// 	    _nb_port_bank_by_bank_read_port    [x] ++;
+	  }
+
+	// init
+// 	for (uint32_t i=0; i<_nb_port_write_by_bank ;i++)
+// 	  _nb_port_bank_by_bank_write_port [i] = 0;
+	
+	for (uint32_t i=0; i<_nb_port_write         ;i++)
+	  {
+	    uint32_t x = i%_nb_port_write_by_bank;
+	    _link_port_write_to_bank_write   [i] = x;
+// 	    _link_port_write_to_num_bank     [i] = _nb_port_bank_by_bank_write_port [x];
+// 	    _nb_port_bank_by_bank_write_port       [x] ++;
+	  }
+
+
+	log_printf(NONE,RegisterFile_Multi_Banked,"Parameters"," * _link_port_read_to_bank_read");
+	for (uint32_t i=0; i<_nb_port_read         ;i++)
+	  log_printf(NONE,RegisterFile_Multi_Banked,"Parameters","   * Read  in  [%d] to out    [%d]",i,_link_port_read_to_bank_read          [i]);
+// 	log_printf(NONE,RegisterFile_Multi_Banked,"Parameters"," * _link_port_read_to_num_bank  ");
+// 	for (uint32_t i=0; i<_nb_port_read         ;i++)
+// 	  log_printf(NONE,RegisterFile_Multi_Banked,"Parameters","   * Read  in  [%d] to bank   [%d]",i,_link_port_read_to_num_bank         [i]);
+
+	log_printf(NONE,RegisterFile_Multi_Banked,"Parameters"," * _link_port_write_to_bank_write");
+	for (uint32_t i=0; i<_nb_port_write        ;i++)
+	  log_printf(NONE,RegisterFile_Multi_Banked,"Parameters","   * Write in  [%d] to out    [%d]",i,_link_port_write_to_bank_write          [i]);
+// 	log_printf(NONE,RegisterFile_Multi_Banked,"Parameters"," * _link_port_write_to_num_bank  ");
+// 	for (uint32_t i=0; i<_nb_port_write        ;i++)
+// 	  log_printf(NONE,RegisterFile_Multi_Banked,"Parameters","   * Write in  [%d] to bank   [%d]",i,_link_port_write_to_num_bank         [i]);
+      }
+    // else : don't allocate
+
+    test();
+    log_printf(FUNC,RegisterFile_Multi_Banked,"Parameters","End");
+  };
+  
+  Parameters::Parameters (Parameters & param):
+    _nb_port_read          (param._nb_port_read         ),
+    _nb_port_write         (param._nb_port_write        ),
+    _nb_word               (param._nb_word              ),
+    _size_word             (param._size_word            ),
+    _nb_bank               (param._nb_bank              ),
+    _nb_port_read_by_bank  (param._nb_port_read_by_bank ),
+    _nb_port_write_by_bank (param._nb_port_write_by_bank),
+    _crossbar              (param._crossbar             ),
+    _size_address          (param._size_address         ),
+    _size_address_by_bank  (param._size_address_by_bank ),
+    _bank_shift            (param._bank_shift           ),
+    _bank_mask             (param._bank_mask            ),
+    _num_reg_shift         (param._num_reg_shift        ),
+    _num_reg_mask          (param._num_reg_mask         ),
+    _nb_word_by_bank       (param._nb_word_by_bank      )
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"Parameters (copy)","Begin");
+
+    if (_crossbar == PARTIAL_CROSSBAR)
+      {
+	// All port_src is connected with one port_dest on each bank
+	
+	_link_port_read_to_bank_read     = new uint32_t [_nb_port_read ];
+// 	_link_port_read_to_num_bank         = new uint32_t [_nb_port_read ];
+	_link_port_write_to_bank_write   = new uint32_t [_nb_port_write];
+// 	_link_port_write_to_num_bank        = new uint32_t [_nb_port_write];
+
+	for (uint32_t i=0; i<_nb_port_read         ;i++)
+	  {
+	    _link_port_read_to_bank_read   [i] = param._link_port_read_to_bank_read     [i];
+// 	    _link_port_read_to_num_bank       [i] = param._link_port_read_to_num_bank    [i];
+	  }
+	for (uint32_t i=0; i<_nb_port_write        ;i++)
+	  {
+	    _link_port_write_to_bank_write [i] = param._link_port_write_to_bank_write    [i];
+// 	    _link_port_write_to_num_bank      [i] = param._link_port_write_to_num_bank   [i];
+	  }
+      }
+
+    test();
+    log_printf(FUNC,RegisterFile_Multi_Banked,"Parameters (copy)","End");
+  };
+
+  Parameters::~Parameters () 
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"~Parameters","Begin");
+
+    if (_crossbar == PARTIAL_CROSSBAR)
+      {
+	delete [] _link_port_read_to_bank_read    ;
+// 	delete [] _link_port_read_to_num_bank   ;
+	delete [] _link_port_write_to_bank_write   ;
+// 	delete [] _link_port_write_to_num_bank  ;
+      }
+    log_printf(FUNC,RegisterFile_Multi_Banked,"~Parameters","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters_msg_error.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters_msg_error.cpp	(revision 53)
@@ -0,0 +1,56 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h"
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Types.h"
+#include <sstream>
+using namespace std;
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  string Parameters::msg_error(void)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"msg_error","Begin");
+
+    string msg = "";
+
+    if (_nb_port_read < _nb_port_read_by_bank)
+      {
+        msg += "  - Each bank read's port must be higher at number of read port\n";
+        msg += "    * nb_port_read                    : " + toString(_nb_port_read        ) + "\n";
+        msg += "    * nb_port_read_by_bank            : " + toString(_nb_port_read_by_bank) + "\n";
+      }
+
+    if (_nb_port_write < _nb_port_write_by_bank)
+      {
+        msg += "  - Each bank write's port must be higher at number of write port\n";
+        msg += "    * nb_port_write                   : " + toString(_nb_port_write        ) + "\n";
+        msg += "    * nb_port_write_by_bank           : " + toString(_nb_port_write_by_bank) + "\n";
+      }
+    
+    if (_nb_bank < 1)
+      {
+        msg += "  - nb_bank must be higher at 1\n";
+        msg += "    * nb_bank                         : " + toString(_nb_bank             ) + "\n";
+      }
+
+    return msg;
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"msg_error","End");
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters_print.cpp	(revision 53)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/src/Parameters_print.cpp	(revision 53)
@@ -0,0 +1,61 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+using namespace std;
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace registerfile {
+namespace registerfile_multi_banked {
+
+
+  string Parameters::print (uint32_t depth)
+  {
+    log_printf(FUNC,RegisterFile_Multi_Banked,"print","Begin");
+
+    XML xml ("registerfile_multi_banked");
+
+    xml.balise_open("registerfile_multi_banked");
+    xml.singleton_begin("nb_port_read         "); xml.attribut("value",toString(_nb_port_read         )); xml.singleton_end();
+    xml.singleton_begin("nb_port_write        "); xml.attribut("value",toString(_nb_port_write        )); xml.singleton_end();
+    xml.singleton_begin("nb_word              "); xml.attribut("value",toString(_nb_word              )); xml.singleton_end();
+    xml.singleton_begin("size_word            "); xml.attribut("value",toString(_size_word            )); xml.singleton_end();
+    xml.singleton_begin("nb_bank              "); xml.attribut("value",toString(_nb_bank              )); xml.singleton_end();
+    xml.singleton_begin("nb_port_read_by_bank "); xml.attribut("value",toString(_nb_port_read_by_bank )); xml.singleton_end();
+    xml.singleton_begin("nb_port_write_by_bank"); xml.attribut("value",toString(_nb_port_write_by_bank)); xml.singleton_end();
+    xml.singleton_begin("crossbar             "); xml.attribut("value",toString(_crossbar             )); xml.singleton_end();
+
+    xml.singleton_begin("size_address         "); xml.attribut("value",toString(_size_address         )); xml.singleton_end();
+    xml.singleton_begin("bank_shift           "); xml.attribut("value",toString(_bank_shift           )); xml.singleton_end();
+    xml.singleton_begin("bank_mask            "); xml.attribut("value",toString(_bank_mask            )); xml.singleton_end();
+    xml.singleton_begin("num_reg_shift        "); xml.attribut("value",toString(_num_reg_shift        )); xml.singleton_end();
+    xml.singleton_begin("num_reg_mask         "); xml.attribut("value",toString(_num_reg_mask         )); xml.singleton_end();
+
+    xml.balise_close();
+
+    log_printf(FUNC,RegisterFile_Multi_Banked,"print","End");
+    
+    return xml.get_body(depth);
+  };
+
+  ostream& operator<< (ostream& output_stream ,
+		       morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters & x)
+  {
+    output_stream << x.print(0);
+    
+    return output_stream;
+  };
+
+}; // end namespace registerfile_multi_banked
+}; // end namespace registerfile
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
